%  % t(0,1).
%  % t(1,1).
%  t(0,2).
%  t(2,3).
%  t(3,2).
%
%  sat(2,geq2).
%  sat(3,geq2).

sat(S0, or(F1,F2)) :- sat(S0, F1).
sat(S0, or(F1,F2)) :- sat(S0, F2).

sat(S0, and(F1, F2)) :-  sat(S0, F1), sat(S0, F2).

sat(S0, not(F)) :- \+ sat(S0, F).

sat(S, ef(X)) :- sat(S,X).
sat(S, ef(X)) :- t(S,S1), sat(S1,ef(X)).

sat(S, eg(X)) :-  \+ sat(S,af(not(X))).

sat(S,af(X)) :- sat(S,X).
sat(S,af(X)) :- t(S,S1), \+ a(S,X).

a(S,X) :- t(S,S1), \+ sat(S1,af(X)).  %not stratified but call-consistent

% sat(S, eg(X)) :-  sat(S,X), t(S,S1), sat(S1,eg(X)).

% sat(S, eg(X)) :-
%         path([S|P]),
%         \+ q(S,P,X).
%
% q(S,P,X) :- member(S1,[S|P]), \+ sat(S1,X).
%
% path(P) :- \+ r(P).
%
% r(P) :- sublist([X,Y],P), \+ t(X,Y).
%
% sublist([X,Y],[X,Y|P]).
% sublist([X,Y],[A|P]) :- sublist([X,Y],P).

p :- sat(0,ef(eg(geq2))).

p1 :- sat(2,eg(geq2)).


% member(X,[X|P]).
% member(X,[Y|P]) :- member(X,P).

