% taken from Delzanno CAV2000
pred_abs(s(I,D,E,SC,SD),I>=0).
pred_abs(s(I,D,E,SC,SD),I>=1).
pred_abs(s(I,D,E,SC,SD),D=:=0).
pred_abs(s(I,D,E,SC,SD),D>=0).
pred_abs(s(I,D,E,SC,SD),D>=1).
pred_abs(s(I,D,E,SC,SD),D>=2).
pred_abs(s(I,D,E,SC,SD),E>=1).
pred_abs(s(I,D,E,SC,SD),E>=0).
pred_abs(s(I,D,E,SC,SD),E=:=0).
pred_abs(s(I,D,E,SC,SD),SC=:=1).
pred_abs(s(I,D,E,SC,SD),SC=:=0).
pred_abs(s(I,D,E,SC,SD),SC>=1).
pred_abs(s(I,D,E,SC,SD),SC>=0).
pred_abs(s(I,D,E,SC,SD),SD=:=1).
pred_abs(s(I,D,E,SC,SD),SD=:=0).
pred_abs(s(I,D,E,SC,SD),SD>=1).
pred_abs(s(I,D,E,SC,SD),SD>=0).
pred_abs(s(I,D,E,SC,SD),D+SC+SD+E>=1).
pred_abs(s(I,D,E,SC,SD),SC+E+SD>=1).
pred_abs(s(I,D,E,SC,SD),SC+SD>=2).



sat(s(I,D,E,SC,SD),el_unsafe) :- D>=2,  I>=0,E>=0,SD>=0,SC>=0.
sat(s(I,D,E,SC,SD),el_unsafe) :- D>=1,  I>=0,E>=0,SD>=0,SC>=0.
sat(s(I,D,E,SC,SD),el_unsafe) :- D>=1,SD>=1,  I>=0,E>=0,SC>=0.

sat(S, not(P)) :- \+ sat(S, P).

sat(S,ef(P)) :- sat(S,P).

sat(s(I,D,E,SC,SD),ef(P)) :-
	I>=0,D>=0,SC>=0,SD>=0,E>=0, 
	D+SC+SD+E>=1,
	
	sat(s(I,D,E,SC,SD),ef(P)).

sat(s(I,D,E,SC,SD),ef(P)) :-
	I>=1,D=:=0,SC=:=0,SD=:=0,E=:=0,

	I1=:=I-1,E1=:=E+1,
	sat(s(I1,D,E1,SC,SD),ef(P)).

sat(s(I,D,E,SC,SD),ef(P)) :-
	I>=1,D>=1,E>=0,SC>=0,SD>=0,

	I1=:=I-1,D1=:=D-1,SD1=:=SD+1,SC1=:=SC+1,
	sat(s(I1,D1,E,SC1,SD1),ef(P)).

sat(s(I,D,E,SC,SD),ef(P)) :-
	I>=1,D=:=0,SC>=0,E>=0,SD>=0, SC+E+SD>=1,

	I1=:=I-1,SC1=:=SC+SD+E+1,E1=:=0,SD1=:=0,
	sat(s(I1,D,E1,SC1,SD1),ef(P)).

sat(s(I,D,E,SC,SD),ef(P)) :-
	D>=1,I>=0,E>=0,SC>=0,SD>=0,
	sat(s(I,D,E,SC,SD),ef(P)).


sat(s(I,D,E,SC,SD),ef(P)) :-
	E>=1,I>=0,SC>=0,SD>=0,D>=0,
	
	D1=:=D+1,E1=:=E-1,
	sat(s(I,D1,E1,SC,SD),ef(P)).

sat(s(I,D,E,SC,SD),ef(P)) :-
	E>=0,I>=0,D>=0,SD=:=1,SC=:=0,
	
	SD1=:=SD-1,D1=:=D+1,
	sat(s(I,D1,E,SC,SD1),ef(P)).

sat(s(I,D,E,SC,SD),ef(P)) :-
	E>=0,I>=0,D>=0,SC=:=1,SD=:=0,

	SC1=:=SC-1,D1=:=D+1,
	sat(s(I,D1,E,SC1,SD),ef(P)).

sat(s(I,D,E,SC,SD),ef(P)) :-
	E>=0,I>=0,D>=0,SC+SD>=2,SC>=0,SD>=0,

	SC1=:=SC+SD-1,SD1=:=1,
	sat(s(I,D,E,SC1,SD1),ef(P)).


sat(s(I,D,E,SC,SD),ef(P)) :-
	I>=1,D=:=0,E=:=0,SC=:=0,SD=:=0,

	I1=:=I-1,D1=:=D+1,
	sat(s(I1,D1,E,SC,SD),ef(P)).

sat(s(I,D,E,SC,SD),ef(P)) :-
	I>=1,D>=1,E>=0,SC>=0,SD>=0,

	I1=:=I-1,D1=:=D-1,SD1=:=SD+1,SC1=:=SC+1,
	sat(s(I1,D1,E,SC1,SD1),ef(P)).

sat(s(I,D,E,SC,SD),ef(P)) :-
	I>=1,D=:=0,SC+E+SD>=1,SC>=0,E>=0,SD>=0,

	I1=:=I-1,SC1=:=SC+SD+E,E1=:=0,SD1=:=1,
	sat(s(I1,D,E1,SC1,SD1),ef(P)).

sat(s(I,D,E,SC,SD),ef(P)) :-
	D>=1, I>=0,SC>=0,SD>=0,E>=0,

	I1=:=I+1,D1=:=D-1,
	sat(s(I1,D1,E,SC,SD),ef(P)).

sat(s(I,D,E,SC,SD),ef(P)) :-
	SC>=1, I>=0,D>=0,SD>=0,E>=0,

	I1=:=I+1,SC1=:=SC-1,
	sat(s(I1,D,E,SC1,SD),ef(P)).

sat(s(I,D,E,SC,SD),ef(P)) :-
	SD>=1, I>=0,SC>=0,D>=0,E>=0,

	I1=:=I+1,SD1=:=SD-1,
	sat(s(I1,D,E,SC,SD1),ef(P)).

sat(s(I,D,E,SC,SD),ef(P)) :-
	E>=1, I>=0,SC>=0,SD>=0,D>=0,

	I1=:=I+1,E1=:=E-1,
	sat(s(I1,D,E1,SC,SD),ef(P)).


safe :- I>=1,D=:=0,SC=:=0,SD=:=0,E=:=0,sat(s(I,D,E,SC,SD),not(ef(el_unsafe))).

%%% memory allocation failed