t(X,Y) :- Y=:=X+1.
t(X,Y) :- Y=:=X-1.

sat(X,geq1) :- X>=1.


sat(S0, or(F1,F2)) :- sat(S0, F1).
sat(S0, or(F1,F2)) :- sat(S0, F2).

sat(S0, and(F1, F2)) :-  sat(S0, F1), sat(S0, F2).

sat(S0, not(F)) :- \+ sat(S0, F).

sat(S, ef(X)) :- sat(S,X).
sat(S, ef(X)) :- t(S,S1), sat(S1,ef(X)).

sat(S, eg(X)) :-  \+ sat(S,af(not(X))).

sat(S,af(X)) :- sat(S,X).

%sat(S,af(X)) :- t(S,S1), \+ a(S,X).
%a(S,X) :- t(S,S1), \+ sat(S1,af(X)).  %not stratified but call-consistent

sat(S,af(X)) :- S1=:=S+1, S2=:=S-1, sat(S1,af(X)), sat(S2,af(X)).


p :- X=:=0, sat(X,ef(eg(geq1))).