pred_abs(s(X,Y),X=:=1).
pred_abs(s(X,Y),X>=0).

%%%
%pred_abs(s(X,Y),X=:=0).
pred_abs(s(X,Y),X=:= -1).
%pred_abs(s(X,Y),X=:= -5).


%t(s(X,a),s(Y,a)) :- Y=:=X+2.
%t(s(X,a),s(Y,b)) :- X=:=1, Y=:= -1.
%t(s(X,b),s(Y,b)) :- Y=:=X-1.

sat(s(X,_),geq0) :- X>=0.
sat(s(X,_),lt0) :- X<0.

sat(S0, or(F1,F2)) :- sat(S0, F1).
sat(S0, or(F1,F2)) :- sat(S0, F2).

sat(S0, and(F1, F2)) :-  sat(S0, F1), sat(S0, F2).

sat(S0, not(F)) :- \+ sat(S0, F).

sat(S, ef(X)) :- sat(S,X).
%sat(S, ef(X)) :- t(S,S1), sat(S1,ef(X)).

%%%sat(s(X,a), ef(P)) :- \+ sat(s(X,a),P), Y=:=X+2, sat(s(Y,a),ef(P)).
%%%sat(s(X,a), ef(P)) :- \+ sat(s(X,a),P), X=:=1,Y=:= -1, sat(s(Y,b),ef(P)).
%%%sat(s(X,b), ef(P)) :- \+ sat(s(X,b),P), Y=:=X-1, sat(s(Y,b),ef(P)).
sat(s(X,a), ef(P)) :- Y=:=X+2, sat(s(Y,a),ef(P)).
sat(s(X,a), ef(P)) :- X=:=1,Y=:= -1, sat(s(Y,b),ef(P)).
%sat(s(X,a), ef(P)) :- X>0,X=<1,Y=:= -1, sat(s(Y,b),ef(P)).

sat(s(X,b), ef(P)) :- Y=:=X-1, sat(s(Y,b),ef(P)).


sat(S, eg(X)) :-  \+ sat(S,af(not(X))).

sat(S,af(X)) :- sat(S,X).
%sat(S,af(X)) :- t(S,S1), \+ a(S,X).
%a(S,X) :- t(S,S1), \+ sat(S1,af(X)).  %not stratified but call-consistent
sat(s(X,a),af(P)) :-  X=:=1, Y=:=X+2, Z=:= -1,
	sat(s(Y,a),af(P)), sat(s(Z,b),af(P)).
%% sat(s(X,a),af(P)) :-  X=\=1, Y=:=X+2, sat(s(Y,a),af(P)).
%sat(s(X,a),af(P)) :-  X<1, Y=:=X+2, sat(s(Y,a),af(P)).
%sat(s(X,a),af(P)) :-  X>1, Y=:=X+2, sat(s(Y,a),af(P)).
sat(s(X,a),af(P)) :-  X=<0, Y=:=X+2, sat(s(Y,a),af(P)).
sat(s(X,a),af(P)) :-  X>1, Y=:=X+2, sat(s(Y,a),af(P)).


sat(s(X,b), af(P)) :- Y=:=X-1, sat(s(Y,b),af(P)).


p1 :- X=:=0, sat(s(X,a),not(ef(not(geq0)))). %% verified
p1a :- X=:=0, sat(s(X,a),not(ef(lt0))). %% verified
p2 :- A=:= -1, sat(s(A,a),ef(not(ef(geq0)))). %% verified
p3 :- A=:= -5, sat(s(A,a),ef(not(ef(geq0)))).
p4 :- X=:= -1, sat(s(X,a),not(ef(lt0))).
