%initial states
pred_abs(s(X,Y),X=:=0).
pred_abs(s(X,Y),Y=:=2).

%conditions
pred_abs(s(X,Y),X>=1).
pred_abs(s(X,Y),Y>=0).
pred_abs(s(X,Y),X>=0).
pred_abs(s(X,Y),Y>=1).

%elementary properties
pred_abs(s(X,Y),Y>2).

%negations
pred_abs(s(X,Y),X>0).
pred_abs(s(X,Y),X<0).
pred_abs(s(X,Y),Y>2).
pred_abs(s(X,Y),Y<2).
pred_abs(s(X,Y),X<1).
pred_abs(s(X,Y),Y<0).
pred_abs(s(X,Y),Y<1).
pred_abs(s(X,Y),Y=<2).


sat(s(X,Y),p) :- X=:=0, Y>2.

sat(s(X,Y),not(P)) :- \+ sat(s(X,Y),P).

sat(S, ef(P)) :- sat(S,P).
sat(s(X,Y),ef(P)) :- 
	X>=1, Y>=0, X1=:=0, Y1=:=Y+2, 
	sat(s(X1,Y1),ef(P)).
sat(s(X,Y),ef(P)) :- 
	X>=0, Y>=1, X1=:=X+2, Y1=:=Y-1, 
	sat(s(X1,Y1),ef(P)).


prop:- X0=:=0, Y0=:=2, sat(s(X0,Y0),ef(p)).
