:- use_module(library(clpfd)).


%%%allinterval(N,Xs) :-
%%%	generate_list(N,LN0),
%%%	permutation(LN0,Xs),
%%%	differences(Xs,Ds),
%%%%	select(0,LN0,LN1), 
%%%%	nth0(_,LN0,0,LN1), 
%%%%	delete(LN0,0,LN1), % do not work as expected
%%%	reverse(LN0,L0N), L0N=[0|L1N],
%%%	permutation(L1N,Ds).


%:- module(allinterval_fd,[allinterval_fd/2]).

allinterval_fd(N,Xs) :-
	length(Xs,N),
	differences(Xs,Ds),
	domain(Xs,0,N),
	all_different(Xs),
	domain(Ds,1,N),
	all_different(Ds),	
	labeling([],Xs).


differences([X,Y],[DXY]) :-
	D#=X-Y,mymod(D,DXY).
differences([X,Y|L],[DXY|Ds]) :-
	D#=X-Y,mymod(D,DXY),differences([Y|L],Ds).

mymod(X,M) :- X#>=0,M#=X.
mymod(X,M) :- X#<0,M+X#=0.

