newai([A]) :- {B=:=2, C=:=1, D=:=0, E=:=1}, 
         newdifferences1(E,F,A), newclplabel1(D,B,A), newclpdelete1(D,B,A), 
         newmyperm1(C,F,B).
newdifferences1(A,[B],C) :- {A=:=1, C=:=1-D}, newmymod1(D,B).
newdifferences1(A,[B|C],D) :- {A=:=1, D=:=1-E}, newmymod1(E,B), 
         gendifferences1(D,C).
newclplabel1(A,B,C) :- {A=:=0, C=:=2, B=:=2}.
newclplabel1(A,B,C) :- {A=:=0, B=:=2, C=\=2}, 
         genclplabel1(C,A).

newclpdelete1(A,B,C) :- {B=:=2, A=:=0, C=:=2}.
newclpdelete1(A,B,C) :- {A=:=0, B=:=2, C=\=2}, 
         genclpdelete1(A,C).
newmyperm1(A,[],B) :- {B=:=2, A=:=1}.
newmyperm1(A,[B|C],D) :- {D=:=2, A=:=1}, newclplabel2(A,B,D), 
         newclpdelete2(E,A,B,D), genmyperm1(C,E).
newclplabel2(A,B,C) :- {A=:=1, B=:=2, C=:=2}.
newclplabel2(A,B,C) :- {A=:=1, C=:=2, B=\=2}, 
         genclplabel1(B,A).

newclpdelete2([A],A,B,C) :- {C=:=2, A=:=1, B=:=2}.
newclpdelete2([A|B],C,D,A) :- {C=:=1, A=:=2, D=\=2}, 
         genclpdelete2(C,D,B).
genmyperm1([],A).
genmyperm1([A|B],C) :- newclplabel3(A,C), newclpdelete3(D,A,C), 
         genmyperm1(B,D).
genclpdelete1(A,B) :- {B=:=A}. %, genclpdelete3(B).
genclpdelete1(A,B) :- {A-B=\=0}. %, genclpdelete3(B).
genclplabel1(A,B) :- {B=:=A}.
genclplabel1(A,B) :- {A-B=\=0}.%, genclplabel2(A).
newmymod1(A,B) :- {B=:=A, A>=0}.
newmymod1(A,B) :- {A<0, B=:= -(A)}.
gendifferences1(A,[B]) :- newmymod2(B).
gendifferences1(A,[B|C]) :- {D=:= -(E)+A}, newmymod1(E,B), gendifferences1(D,C).
newclplabel3(A,[B|C]) :- {B=:=A}.
newclplabel3(A,[B|C]) :- {A-B=\=0}, newclplabel3(A,C).
newclpdelete3([],A,[]).
newclpdelete3(A,B,[C|D]) :- {B=:=C}, newclpdelete3(A,B,D).
newclpdelete3([A|B],C,[A|D]) :- {A-C=\=0}, newclpdelete3(B,C,D).
genclpdelete2(A,B,C) :- {B=:=A}, genclpdelete4(B,C).
genclpdelete2(A,B,[A|C]) :- {A-B=\=0}, genclpdelete4(B,C).
%genclpdelete3(A).
%genclpdelete3(A) :- {genclpdelete3(A).
%genclpdelete3(A) :- {A-B=\=0}, genclpdelete3(A).
%genclplabel2(A).
%genclplabel2(A) :- {A-B=\=0}, genclplabel2(A).
newmymod2(A) :- {A>=0}.
%newmymod2(A) :- {A>0}.
genclpdelete4(A,[]).
%genclpdelete4(A,B) :- genclpdelete4(A,B).
genclpdelete4(A,[B|C]) :- {B-A=\=0}, genclpdelete4(A,C).
