%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Mortgage example from 3 R's 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


mg_s(P,T,I,R,B) :- I>=0, R>=0, B>=0, mg(P,T,I,R,B).


mg(P,T,I,R,B) :-
	    T = 1,
	    B = P * (1 + I/1200) - R.
mg(P,T,I,R,B) :-
	    T >= 2,
	    T1 = T - 1,
	    P1 = P * (1 + I/1200) - R,
	    P1 >=0,
	    mg(P1, T1, I, R, B).
