% mmod(I,J,M) holds iff
% M is |I| + |I+1| + ... + |J-2| + |J-1|


mmod_s(I,J,M) :- I=:=0, J>=0, mmod(I,J,M).

mmod(I,J,M) :- I>=J, M=:=0.
mmod(I,J,M) :- I<J, I1=:=I+1, M=:=M1+L, mymod(I,L), mmod(I1,J,M1).

mymod(X,M) :- X>=0, M=:=X.
mymod(X,M) :- X<0, M=:=(-X).

