mode(m_match,[+,+,+]).
mode(match,[+,+,+]).
mode(prefix_int,[+,+,+]).


m_match([W|Ws],K,T) :-
	match(W,K,T).
m_match([W|Ws],K,T) :-
	m_match(Ws,K,T).

match(W,K,T) :-
	prefix_int(W,K,T).
match(W,K,[_|T]) :-
	match(W,K,T).



prefix_int([],_,_).
prefix_int([A|B],K,[C|D]) :-
	A>=C,
	A-C=<K,
	prefix_int(B,K,D).
prefix_int([A|B],K,[C|D]) :-
	A<C,C-A=<K,
	prefix_int(B,K,D).



%%% solver:clpq
%%% uf: leftmost_consumer
%%% wqounf: none
%%% Z=:=0, U=:=1, D=:=2, T=:=3, Q=:=4,

%%% TODO
%%% sp_mm(A) :-  U=:=1, D=:=2, m_match([[U,U],[U,D]],U,A). % out of memory: probably a problem during case split wrt terms. CHECK!
%%% sp_mm(A) :-  U=:=1, D=:=2, m_match([[U,U,U],[U,U,D]],D,A).
%%% sp_mm(A) :-  U=:=1, D=:=2, m_match([[U,U,U],[U,U,D],[U,U]],A). 
%%% sp_mm(A) :-  U=:=1, D=:=2,  T=:=3, m_match([[U,U,D],[U,D,T]],A).
%%% sp_mm(A) :-  U=:=1, D=:=2,  m_match([[U,U,D],[U,D,D]],A).