make_prop([],[]).
make_prop([CN|CNs],[Cl|Cls]) :-
	clause_hd_bd(CN,H,B),
	B = bd(C,As),
	make_prop_body(As,PAs),
	functor(H,F,_),
	Cl = (F,bd(C,PAs)),
	make_prop(CNs,Cls).

make_prop_body([],[]).
make_prop_body([L|Ls],[PL|PLs]) :-
	( is_a_negative_literal(L,A1) ->
		 A=A1,
		 functor(A,F,_),
		 PL=not(F)
	;
		 A=L,
		 functor(A,F,_),
		 PL = F 
	),
	make_prop_body(Ls,PLs).