#!/usr/bin/wish -f 

set DIR [pwd]
#set DIR [basename $cwd]
set dirNameProg $env(NEWMAP_DIR)/Programs
set dirNameTheories $env(NEWMAP_DIR)/Theories
set dirNameSessions $env(NEWMAP_DIR)/Sessions
set dirNameHistories $env(NEWMAP_DIR)/Histories

set help 0
set trace 0
set zip 0

set R_or_S ""
set proofSelection ""
set defSelection ""
set lawSelection ""
set solverSelection ""

set tagsSelection ""
set deftagsSelection ""
set fontcl courier16
#set fontcl helvetica16
set fontclnum {Courier 16 bold}
set fonthistory bold14
set font {Times 12 bold}


source $env(NEWMAP_DIR)/src_tcl/control.tcl
source $env(NEWMAP_DIR)/src_tcl/help_rules.tcl
source $env(NEWMAP_DIR)/src_tcl/rules.tcl
source $env(NEWMAP_DIR)/src_tcl/basics.tcl
source $env(NEWMAP_DIR)/src_tcl/trace.tcl
source $env(NEWMAP_DIR)/src_tcl/zip.tcl
source $env(NEWMAP_DIR)/src_tcl/display.tcl

source $env(NEWMAP_DIR)/src_tcl/css_param.tcl
source $env(NEWMAP_DIR)/src_tcl/ds_param.tcl

