pred_abs(s(_,A,_,B),A<B).
pred_abs(s(_,A,_,B),B=:=0).
pred_abs(s(_,A,_,B),B<A).
pred_abs(s(_,A,_,B),A=:=0).


sat(s(u,A,u,B),el_unsafe).
sat(s(w,A,B,C),el_wait).
sat(s(u,A,B,C),el_use).
sat(A,or(B,C)) :- sat(A,B).
sat(A,or(B,C)) :- sat(A,C).
sat(A,and(B,C)) :- sat(A,B), sat(A,C).
sat(A,not(B)) :- \+sat(A,B).
sat(A,ef(B)) :- sat(A,B).


%%%%%%%%%%%%%%%%%%%%%
%%%sat(s(t,A,t,B),ef(C)) :- D=:=B+1, A>=0, B>=0, sat(s(w,D,t,B),ef(C)).
%%%sat(s(t,A,w,B),ef(C)) :- D=:=B+1, A>=0, B>=0, sat(s(w,D,w,B),ef(C)).
%%%sat(s(t,A,u,B),ef(C)) :- D=:=B+1, A>=0, B>=0, sat(s(w,D,u,B),ef(C)).

%%%sat(s(w,A,t,B),ef(C)) :- A<B, A>=0, sat(s(u,A,t,B),ef(C)).
%%%sat(s(w,A,w,B),ef(C)) :- A<B, A>=0, sat(s(u,A,w,B),ef(C)).
%%%sat(s(w,A,u,B),ef(C)) :- A<B, A>=0, sat(s(u,A,u,B),ef(C)).

%%%sat(s(w,A,t,B),ef(C)) :- B=:=0, A>=0, sat(s(u,A,t,B),ef(C)).
%%%sat(s(w,A,w,B),ef(C)) :- B=:=0, A>=0, sat(s(u,A,w,B),ef(C)).
%%%sat(s(w,A,u,B),ef(C)) :- B=:=0, A>=0, sat(s(u,A,u,B),ef(C)).

%%%sat(s(u,A,t,B),ef(C)) :- D=:=0, A>=0, B>=0, sat(s(t,D,t,B),ef(C)).
%%%sat(s(u,A,w,B),ef(C)) :- D=:=0, A>=0, B>=0, sat(s(t,D,w,B),ef(C)).
%%%sat(s(u,A,u,B),ef(C)) :- D=:=0, A>=0, B>=0, sat(s(t,D,u,B),ef(C)).

%%%sat(s(t,A,t,B),ef(C)) :- D=:=A+1, A>=0, sat(s(t,A,w,D),ef(C)).
%%%sat(s(w,A,t,B),ef(C)) :- D=:=A+1, A>=0, sat(s(w,A,w,D),ef(C)).
%%%sat(s(u,A,t,B),ef(C)) :- D=:=A+1, A>=0, sat(s(u,A,w,D),ef(C)).

%%%sat(s(t,A,w,B),ef(C)) :- B<A, B>=0, sat(s(t,A,u,B),ef(C)).
%%%sat(s(w,A,w,B),ef(C)) :- B<A, B>=0, sat(s(w,A,u,B),ef(C)).
%%%sat(s(u,A,w,B),ef(C)) :- B<A, B>=0, sat(s(u,A,u,B),ef(C)).

%%%sat(s(t,A,w,B),ef(C)) :- A=:=0, B>=0, sat(s(t,A,u,B),ef(C)).
%%%sat(s(w,A,w,B),ef(C)) :- A=:=0, B>=0, sat(s(w,A,u,B),ef(C)).
%%%sat(s(u,A,w,B),ef(C)) :- A=:=0, B>=0, sat(s(u,A,u,B),ef(C)).

%%%sat(s(t,A,u,B),ef(C)) :- D=:=0, B>=0, A>=0, sat(s(t,A,t,D),ef(C)).
%%%sat(s(w,A,u,B),ef(C)) :- D=:=0, B>=0, A>=0, sat(s(w,A,t,D),ef(C)).
%%%sat(s(u,A,u,B),ef(C)) :- D=:=0, B>=0, A>=0, sat(s(u,A,t,D),ef(C)).
%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
sat(s(t,A,S,B),ef(C)) :- D=:=B+1, A>=0, B>=0, sat(s(w,D,S,B),ef(C)).
sat(s(w,A,S,B),ef(C)) :- A<B, A>=0, sat(s(u,A,S,B),ef(C)).
sat(s(w,A,S,B),ef(C)) :- B=:=0, A>=0, sat(s(u,A,S,B),ef(C)).
sat(s(u,A,S,B),ef(C)) :- D=:=0, A>=0, B>=0, sat(s(t,D,S,B),ef(C)).
sat(s(S,A,t,B),ef(C)) :- D=:=A+1, A>=0, sat(s(S,A,w,D),ef(C)).
sat(s(S,A,w,B),ef(C)) :- B<A, B>=0, sat(s(S,A,u,B),ef(C)).
sat(s(S,A,w,B),ef(C)) :- A=:=0, B>=0, sat(s(S,A,u,B),ef(C)).
sat(s(S,A,u,B),ef(C)) :- D=:=0, B>=0, A>=0, sat(s(S,A,t,D),ef(C)).
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


sat(A,eg(B)) :- \+sat(A,af(not(B))).

sat(A,af(B)) :- sat(A,B).
sat(s(t,T1,t,T2),af(P)) :- T3=:=T2+1,T4=:=T1+1,
	sat(s(w,T3,t,T2),af(P)),sat(s(t,T1,w,T4),af(P)).
sat(s(t,T1,u,T2),af(P)) :- T3=:=T2+1,T4=:=0,
	sat(s(w,T3,u,T2),af(P)),sat(s(t,T1,t,T4),af(P)).
sat(s(t,T1,w,T2),af(P)) :- T3=:=T2+1,T2<T1,
	sat(s(w,T3,w,T2),af(P)),sat(s(t,T1,u,T2),af(P)).
sat(s(t,T1,w,T2),af(P)) :- T3=:=T2+1,T1=:=0,
	sat(s(w,T3,w,T2),af(P)),sat(s(t,T1,u,T2),af(P)).
sat(s(t,T1,w,T2),af(P)) :- T3=:=T2+1,T1>0,T1=<T2,  % should be T1=\=0?
	sat(s(w,T3,w,T2),af(P)).
sat(s(u,T1,u,T2),af(P)) :- T3=:=0,T4=:=0,
	sat(s(t,T3,u,T2),af(P)),sat(s(u,T1,t,T4),af(P)).
sat(s(u,T1,w,T2),af(P)) :- T3=:=0,T2<T1,
	sat(s(t,T3,w,T2),af(P)),sat(s(u,T1,u,T2),af(P)).
sat(s(u,T1,w,T2),af(P)) :- T3=:=0,T1=:=0,
	sat(s(t,T3,w,T2),af(P)),sat(s(u,T1,u,T2),af(P)).
sat(s(u,T1,w,T2),af(P)) :- T3=:=0,T1>0,T1=<T2,  % T1=\=0
	sat(s(t,T3,w,T2),af(P)).
%%% DELETED
%%% sat(s(w,T1,w,T2),af(P)) :- T1<T2, sat(s(u,T1,w,T2),af(P)),
%%%	T2<T1, sat(s(w,T1,u,T2),af(P)).
sat(s(w,T1,w,T2),af(P)) :- T1<T2, T1=:=0,
	sat(s(u,T1,w,T2),af(P)), sat(s(w,T1,u,T2),af(P)).
sat(s(w,T1,w,T2),af(P)) :- T1<T2, T1>0, % should be T1=\=0?
	sat(s(u,T1,w,T2),af(P)).
sat(s(w,T1,w,T2),af(P)) :- T2=:=0, T1=:=0,
	sat(s(u,T1,w,T2),af(P)), sat(s(w,T1,u,T2),af(P)).
% for symmetrical transitions
sat(s(u,T2,t,T1),af(P)) :- T3=:=T2+1,T4=:=0,
	sat(s(u,T2,w,T3),af(P)),sat(s(t,T4,t,T1),af(P)).
sat(s(w,T2,t,T1),af(P)) :- T3=:=T2+1,T2<T1,
	sat(s(w,T2,w,T3),af(P)),sat(s(u,T2,t,T1),af(P)).
sat(s(w,T2,t,T1),af(P)) :- T3=:=T2+1,T1=:=0,
	sat(s(w,T2,w,T3),af(P)),sat(s(u,T2,t,T1),af(P)).
sat(s(w,T2,t,T1),af(P)) :- T3=:=T2+1,T1>0,T1=<T2,  % should be T1=\=0?
	sat(s(w,T2,w,T3),af(P)).
sat(s(u,T2,u,T1),af(P)) :- T3=:=0,T4=:=0,
	sat(s(u,T2,t,T3),af(P)),sat(s(t,T4,u,T1),af(P)).
sat(s(w,T2,u,T1),af(P)) :- T3=:=0,T2<T1,
	sat(s(w,T2,t,T3),af(P)),sat(s(u,T2,u,T1),af(P)).
sat(s(w,T2,u,T1),af(P)) :- T3=:=0,T1=:=0,
	sat(s(w,T2,t,T3),af(P)),sat(s(u,T2,u,T1),af(P)).
sat(s(w,T2,u,T1),af(P)) :- T3=:=0,T1>0,T1=<T2,  % should be T1=\=0
	sat(s(w,T2,t,T3),af(P)).
sat(s(w,T2,w,T1),af(P)) :- T1<T2, T1=:=0,
	sat(s(w,T2,u,T1),af(P)), sat(s(u,T2,w,T1),af(P)).
sat(s(w,T2,w,T1),af(P)) :- T1<T2, T1>0, % should be T1=\=0?
	sat(s(w,T2,u,T1),af(P)).
sat(s(w,T2,w,T1),af(P)) :- T2=:=0, T1=:=0,
	sat(s(w,T2,u,T1),af(P)), sat(s(u,T2,w,T1),af(P)).



safe :- A=:=0, B=:=0, sat(s(t,A,t,B),not(ef(el_unsafe))).
starvfree :- A=:=0, B=:=0, sat(s(t,A,t,B),not(ef(and(el_wait,not(af(el_use)))))).

%%%
%%%initial def: safe1 :- A=:=0, B=:=0, sat(s(t,A,t,B),not(ef(el_unsafe))).
%%%solver: clpq
%%%uf: ctl
%%%wqounf: ctl
%%%verification: yes
%%%
%%% Spec. time: 660ms


%%%safe1 :- A=:=0, B=:=0, not(newsat2(A,B)).
%%%newsat2(A,B) :- newsat3(A,B).
%%%newsat2(A,B) :- C=:=1, newsat4(C,B).
%%%newsat2(A,B) :- C=:=1, newsat5(C,A).
%%%newsat5(A,B) :- newsat6(B,A).
%%%newsat5(A,B) :- C=:=1+A, newsat7(C,A).
%%%newsat5(A,B) :- newsat8(B,A).
%%%newsat4(A,B) :- newsat9(A,B).
%%%newsat4(A,B) :- newsat10(A,B).
%%%newsat4(A,B) :- C=:=1+A, newsat11(C,A).
%%%newsat11(A,B) :- newsat12(B,A).
%%%newsat11(A,B) :- newsat13(B,A).
%%%newsat10(A,B) :- newsat14(A,B).
%%%newsat10(A,B) :- C=:=0, newsat2(C,B).
%%%newsat10(A,B) :- C=:=1+A, newsat13(A,C).
%%%newsat8(A,B) :- newsat17(A,B).
%%%newsat8(A,B) :- C=:=1+B, newsat18(C,B).
%%%newsat8(A,B) :- C=:=0, newsat2(A,C).
%%%newsat7(A,B) :- newsat20(A,B).
%%%newsat7(A,B) :- newsat18(A,B).
%%%newsat18(A,B) :- newsat22(A,B).
%%%newsat18(A,B) :- C=:=0, newsat4(A,C).
%%%newsat13(A,B) :- newsat24(A,B).
%%%newsat13(A,B) :- C=:=0, newsat5(B,C).


%%%
%%%initial def: stfree1 :- A=:=0, B=:=0, sat(s(t,A,t,B),not(ef(and(el_wait,not(af(el_use)))))).
%%%solver: clpq
%%%uf: ctl
%%%wqounf: ctl
%%%verification: yes
%%%
%%% Spec. time: 2610ms

%%%newsat20(A,B).
%%%newsat41(A,B).
%%%newsat30(A,B).
%%%newsat54(A,B).
%%%newsat66(A,B).
%%%newsat72(A,B).
%%%stfree1 :- A=:=0, B=:=0, not(newsat2(A,B)).
%%%newsat2(A,B) :- newsat3(A,B).
%%%newsat2(A,B) :- C=:=1, newsat4(C,B).
%%%newsat2(A,B) :- C=:=1, newsat5(C,A).
%%%newsat5(A,B) :- newsat6(B,A).
%%%newsat5(A,B) :- C=:=1+A, newsat7(C,A).
%%%newsat5(A,B) :- newsat8(B,A).
%%%newsat4(A,B) :- newsat9(A,B).
%%%newsat4(A,B) :- newsat10(A,B).
%%%newsat4(A,B) :- C=:=1+A, newsat11(C,A).
%%%newsat3(A,B) :- newsat12(A,B), newsat13(A,B).
%%%newsat13(A,B) :- not(newsat14(A,B)).
%%%newsat11(A,B) :- newsat15(B,A).
%%%newsat11(A,B) :- newsat16(B,A).
%%%newsat10(A,B) :- newsat17(A,B).
%%%newsat10(A,B) :- C=:=0, newsat2(C,B).
%%%newsat10(A,B) :- C=:=1+A, newsat16(A,C).
%%%newsat9(A,B) :- newsat20(A,B), newsat21(A,B).
%%%newsat8(A,B) :- newsat22(A,B).
%%%newsat8(A,B) :- C=:=1+B, newsat23(C,B).
%%%newsat8(A,B) :- C=:=0, newsat2(A,C).
%%%newsat7(A,B) :- newsat25(A,B).
%%%newsat7(A,B) :- newsat23(A,B).
%%%newsat6(A,B) :- newsat27(A,B), newsat28(A,B).
%%%newsat28(A,B) :- not(newsat29(A,B)).
%%%newsat25(A,B) :- newsat30(A,B), newsat31(A,B).
%%%newsat23(A,B) :- newsat32(A,B).
%%%newsat23(A,B) :- C=:=0, newsat4(A,C).
%%%newsat22(A,B) :- newsat34(A,B), newsat35(A,B).
%%%newsat21(A,B) :- not(newsat36(A,B)).
%%%newsat17(A,B) :- newsat37(A,B), newsat38(A,B).
%%%newsat16(A,B) :- newsat39(A,B).
%%%newsat16(A,B) :- C=:=0, newsat5(B,C).
%%%newsat15(A,B) :- newsat41(A,B), newsat42(A,B).
%%%newsat14(A,B) :- newsat43(A,B).
%%%newsat14(A,B) :- C=:=1, D=:=1, newsat36(D,B),
%%% newsat29(A,C).
%%%newsat42(A,B) :- not(newsat46(A,B)).
%%%newsat39(A,B) :- newsat47(A,B), newsat48(A,B).
%%%newsat38(A,B) :- not(newsat49(A,B)).
%%%newsat36(A,B) :- newsat50(A,B).
%%%newsat36(A,B) :- C=:=1+A, newsat46(A,C),
%%% newsat49(A,B).
%%%newsat35(A,B) :- not(newsat53(A,B)).
%%%newsat32(A,B) :- newsat54(A,B), newsat55(A,B).
%%%newsat31(A,B) :- not(newsat56(A,B)).
%%%newsat29(A,B) :- newsat57(A,B).
%%%newsat29(A,B) :- C=:=1+B, newsat56(C,B),
%%% newsat53(A,B).
%%%newsat56(A,B) :- newsat60(A,B).
%%%newsat56(A,B) :- newsat61(A,B).
%%%newsat55(A,B) :- not(newsat61(A,B)).
%%% newsat53(A,B) :- newsat63(A,B).
%%% newsat53(A,B) :- C=:=0, D=:=1+B,
%%% newsat61(D,B), newsat14(A,C).
%%% newsat49(A,B) :- newsat66(A,B).
%%% newsat49(A,B) :- C=:=0, D=:=1+A,
%%% newsat67(D,A), newsat14(C,B).
%%% newsat48(A,B) :- not(newsat67(B,A)).
%%% newsat46(A,B) :- newsat70(A,B).
%%% newsat46(A,B) :- newsat67(B,A).
%%% newsat67(A,A) :- newsat72(A,A).
%%% newsat67(A,B) :- C=:=0, newsat29(C,A).
%%% newsat61(A,B) :- newsat74(A,B).
%%% newsat61(A,B) :- C=:=0, newsat36(A,C).