t(s(X,a),s(Y,b)) :- Y=:=X+1.
t(s(X,b),s(Y,c)) :- Y=:=X+1.
t(s(X,c),s(Y,b)) :- Y=:=X+2.

sat(s(X,_),geq2) :- X>=2.

p :- X=:=0, sat(s(X,a),ef(eg(geq2))).


sat(S0, or(F1,F2)) :- sat(S0, F1).
sat(S0, or(F1,F2)) :- sat(S0, F2).

sat(S0, and(F1, F2)) :-  sat(S0, F1), sat(S0, F2).

sat(S0, not(F)) :- \+ sat(S0, F).

sat(S, ef(X)) :- sat(S,X).
sat(S, ef(X)) :- t(S,S1), sat(S1,ef(X)).

sat(S, eg(X)) :-  \+ sat(S,af(not(X))).

sat(S,af(X)) :- sat(S,X).
sat(S,af(X)) :- t(S,S1), \+ a(S,X).

a(S,X) :- t(S,S1), \+ sat(S1,af(X)).  %not stratified but call-consistent


