%%% Derivation time 530 ms
%%% Strategy bakery.pl

%%%:- consult('$NEWMAP_DIR/Solvers/clpq.pl').
%%%:- consult('$NEWMAP_DIR/UnfoldFuncs/leftmost.pl').
%%%:- consult('$NEWMAP_DIR/Wqounfs/embed.pl').
%%%:- consult('$NEWMAP_DIR/Wqogens/embed.pl').
%%%:- consult('$NEWMAP_DIR/Widenings/simple.pl').

%%% Initial program
p(A,a) :- A=:=B+2, p(B,a).
p(A,b) :- B=:=1, A=:= -1, p(B,a).
p(A,b) :- A=:=B-1, p(B,b).
p(A,a) :- A=:=0.
unsafe :- A<0, p(A,B).


%%% Final Program
punsafe :- A< -4, newp1(A).
punsafe :- A=:= -1, newp2(A).
punsafe :- A=:= -1, newp2(A).
punsafe :- A<2, newp3(A).
newp1(A) :- B=:= -2+A, newp1(B).
newp2(A) :- B=:= -3, genp2(B).
newp3(A) :- B=:= -1, A=:= -1, newp2(B).
newp3(A) :- B=:=1+A, genp1(B).
genp1(A) :- B=:= -1, A=:= -1, newp2(B).
genp1(A) :- B=:=1+A, genp1(B).
genp2(A) :- B=:= -2+A, genp2(B).

%%% Definitions
%%%6. punsafe :- A<0, p(A,B).
%%%15. newp1(A) :- A< -4, p(A,a).
%%%17. newp2(A) :- A=:= -1, p(A,a).
%%%20. newp3(A) :- A<2, p(A,b).
%%%28. genp1(A) :- p(A,b).
%%%30. genp2(A) :- A=< -1, p(A,a).

%%%** DefsForest **
%%%[[[28,20,6],[30,17,6],[15,6]]]

%%% Generalizations
%%% 28-20
%%% 30-17