% taken from Delzanno CAV2000

pred_abs(s(I,D,S,E),D>=2).
pred_abs(s(I,D,S,E),D>=1).
pred_abs(s(I,D,S,E),D>=0).
pred_abs(s(I,D,S,E),D=:=0).
pred_abs(s(I,D,S,E),I>=0).
pred_abs(s(I,D,S,E),I>=1).
pred_abs(s(I,D,S,E),S>=0).
pred_abs(s(I,D,S,E),S>=1).
pred_abs(s(I,D,S,E),S>=2).
pred_abs(s(I,D,S,E),S=:=0).
pred_abs(s(I,D,S,E),E>=0).
pred_abs(s(I,D,S,E),E>=1).
pred_abs(s(I,D,S,E),E=:=0).
pred_abs(s(I,D,S,E),S+E>=1).
pred_abs(s(I,D,S,E),D+S+E>=1).




sat(s(I,D,S,E),el_unsafe) :- D>=2,  I>=0,S>=0,E>=0.
sat(s(I,D,S,E),el_unsafe) :- D>=1,S>=1,  I>=0,E>=0.

sat(S, not(P)) :- \+ sat(S,P).

sat(S,ef(P)) :- sat(S,P).

sat(s(I,D,S,E),ef(P)) :-
	I>=0,D>=0,S>=0,E>=0,D+S+E>=1,

	sat(s(I,D,S,E),ef(P)).


sat(s(I,D,S,E),ef(P)) :-
	I>=1,D=:=0,S=:=0,E=:=0,

	I1=:=I-1,E1=:=E+1,
	sat(s(I1,D,S,E1),ef(P)).

sat(s(I,D,S,E),ef(P)) :-
	I>=1,D>=1,S>=0,E>=0,

	I1=:=I-1,D1=:=D-1,S1=:=S+2,
	sat(s(I1,D1,S1,E),ef(P)).

sat(s(I,D,S,E),ef(P)) :-
	I>=1,S>=0,D>=0,E>=0, S+E>=1,

	I1=:=I-1,S1=:=S+E+1,E1=:=0,
	sat(s(I1,D,S1,E1),ef(P)).

sat(s(I,D,S,E),ef(P)) :-
	I>=0,D>=1,S>=0,E>=0,
	
	sat(s(I,D,S,E),ef(P)).

sat(s(I,D,S,E),ef(P)) :-
	I>=0,D>=0,S>=0,E>=1,

	D1=:=D+1,E1=:=E-1,
	sat(s(I,D1,S,E1),ef(P)).

sat(s(I,D,S,E),ef(P)) :-
	I>=0,D>=0,S=:=1,E>=0,

	E1=:=E+1,S1=:=S-1,
	sat(s(I,D,S1,E1),ef(P)).

sat(s(I,D,S,E),ef(P)) :-
	I>=0,D>=0,S>=2,E>=0,
	
	sat(s(I,D,S,E),ef(P)).

sat(s(I,D,S,E),ef(P)) :-
	I>=1,D=:=0,S=:=0,E=:=0,

	I1=:=I-1,D1=:=D+1,
	sat(s(I1,D1,S,E),ef(P)).

sat(s(I,D,S,E),ef(P)) :-
	I>=1,D>=1,S>=0,E>=0,

	I1=:=I-1,D1=:=D-1,  S1=:=S+2,
	sat(s(I1,D1,S1,E),ef(P)).

sat(s(I,D,S,E),ef(P)) :-
	I>=1,D>=0,S>=0,E>=0, S+E>=1,

	I1=:=I-1,S1=:=S+E+1,E1=:=0,
	sat(s(I1,D,S1,E1),ef(P)).

sat(s(I,D,S,E),ef(P)) :-
	I>=0,D>=1,S>=0,E>=0,

	I1=:=I+1,D1=:=D-1,
	sat(s(I1,D1,S,E),ef(P)).

sat(s(I,D,S,E),ef(P)) :-
	I>=0,D>=0,S>=1,E>=0,

	I1=:=I+1,S1=:=S-1,
	sat(s(I1,D,S1,E),ef(P)).

sat(s(I,D,S,E),ef(P)) :-
	I>=0,D>=0,S>=0,E>=1,

	I1=:=I+1,E1=:=E-1,
	sat(s(I1,D,S,E1),ef(P)).


safe :- I>=1,D=:=0,S=:=0,E=:=0,sat(s(I,D,S,E),not(ef(el_unsafe))).

%%% ERROR: Memory allocation failed