
%initial states
pred_abs(s(X,Y),X=:=0).
pred_abs(s(X,Y),Y=:=2).

%conditions
pred_abs(s(X,Y),X>=1).
pred_abs(s(X,Y),Y>=1).

%actions
pred_abs(s(X,Y),Y>=0).

%elementary properties
pred_abs(s(X,Y),Y>2).

%negations
%%%pred_abs(s(X,Y),X>0).
%%%pred_abs(s(X,Y),X<0).
%%%pred_abs(s(X,Y),Y>2).
%%%pred_abs(s(X,Y),Y<2).
%%%pred_abs(s(X,Y),X<1).
%%%pred_abs(s(X,Y),Y<1).
%%%pred_abs(s(X,Y),Y<0).
%%%pred_abs(s(X,Y),Y=<2).


sat(s(X,Y),p,T) :- X=:=0, Y>2.
sat(S, ef(P),T) :- sat(S,P,_).
sat(s(X,Y),ef(P),[a1|T]) :- 
	X>=1, X1=:=0, Y1=:=Y+2, 
	sat(s(X1,Y1),ef(P),T).
sat(s(X,Y),ef(P),[a2|T]) :- 
	Y>=1, X1=:=X+2, Y1=:=Y-1, 
	sat(s(X1,Y1),ef(P),T).


prop(X0,Y0,T):- X0=:=0, Y0=:=2, sat(s(X0,Y0),ef(p),T).
