% initial state
pred_abs(s(X,Y),X=:=1).
pred_abs(s(X,Y),Y=:=0).
% conditions
pred_abs(s(X,Y),X>=1).
pred_abs(s(X,Y),Y>=1).
% actions
% a1
pred_abs(s(X,Y),X=:=0).
% a2
% pred_abs(s(X,Y),Y>=0). % redundant


%sat(s(X,Y),el_p) :- X=:=3, Y=:=0.
%pred_abs(s(X,Y),X=:=3).

%sat(s(X,Y),el_p2) :- X-Y>1.
%pred_abs(s(X,Y),X-Y>1).


%%%sat(s(X,Y),el_p2, []) :- X<Y.
%%%pred_abs(s(X,Y),X<Y).

sat(s(X,Y),el_p3) :- X>2.
pred_abs(s(X,Y),X>2).



sat(S0, not(F)) :- \+ sat(S0, F).

sat(S, ef(P)) :- sat(S,P).
sat(s(X,Y),ef(P)) :- X>=1, X1=:=0, Y1=:=Y+1, sat(s(X1,Y1),ef(P)).
sat(s(X,Y),ef(P)) :- Y>=1, X1=:=X+2, Y1=:=Y-1, sat(s(X1,Y1),ef(P)).


sat(S, af(P)) :- sat(S,P).
sat(s(X,Y),af(P)) :-
	X>=1, Y>=1,
	X1=:=0, Y1=:=Y+1,
	X2=:=X+2, Y2=:=Y-1,
	sat(s(X1,Y1),af(P)), sat(s(X2,Y2),af(P)).
sat(s(X,Y),af(P)) :-
	X>=1, Y<1,
	X1=:=0, Y1=:=Y+1,
	sat(s(X1,Y1),af(P)).
sat(s(X,Y),af(P) ) :-
	X<1, Y>=1,
	X2=:=X+2, Y2=:=Y-1,
	sat(s(X2,Y2),af(P)).








prop :- X=:=1,Y=:=0, sat(s(X,Y),ef(el_p)).
prop2 :- X=:=1,Y=:=0, sat(s(X,Y),not(ef(el_p2))).
prop3 :- X=:=1,Y=:=0, sat(s(X,Y),af(el_p3)).

