
mode(match,[+,+]).
mode(app,[-,-,+]).
mode(match_int,[+,+,+]).


match(A,K,B) :- app(C,D,B), app(E,F,C), match_int(A,K,F).

app([],A,A).
app([A|B],C,[A|D]) :- app(B,C,D).

match_int([],_,[]).
match_int([A|B],K,[C|D]) :-
	A>=C,
	A-C=<K, match_int(B,K,D).
match_int([A|B],K,[C|D]) :- A<C,C-A=<K, match_int(B,K,D).


%%% solver:clpq
%%% uf: leftmost_weak_consumer
%%% wqounf: none

%%% sp_match(A) :- Z=:=0, D=:=2, match([D,Z],D,A).

%%% newp10(A).
%%% newp8(A).
%%% sp_match(A) :- newp2(A).
%%% newp2([A|B]) :- A>=0, A=<2, newp3(B).
%%% newp2([A|B]) :- A<0, newp2(B).
%%% newp2([A|B]) :- A>2, A=<4, newp3(B).
%%% newp2([A|B]) :- A>4, newp2(B).
%%% newp3([A|B]) :- A>2, A=<4, newp3(B).
%%% newp3([A|B]) :- A>0, A=<2, newp8(B).
%%% newp3([A|B]) :- A=:=0, newp8(B).
%%% newp3([A|B]) :- A>= -2, A<0, newp10(B).
%%% newp3([A|B]) :- A< -2, newp2(B).
%%% newp3([A|B]) :- A>4, newp2(B).


%%% sp_match(A) :- Z=:=0, D=:=2, Q=:=4, T=:=3, match([D,Z,Q],T,A).

%%% newp21(A).
%%% newp19(A).
%%% newp14(A).
%%% sp_match(A) :- newp2(A).
%%% newp2([A|B]) :- A>= -1, A=<2, newp3(B).
%%% newp2([A|B]) :- A< -1, newp2(B).
%%% newp2([A|B]) :- A>2, A=<5, newp3(B).
%%% newp2([A|B]) :- A>5, newp2(B).
%%% newp3([A|B]) :- A>2, A=<3, newp7(B).
%%% newp3([A|B]) :- A>3, A=<5, newp3(B).
%%% newp3([A|B]) :- A>0, A=<2, newp7(B).
%%% newp3([A|B]) :- A>= -1, A=<0, newp7(B).
%%% newp3([A|B]) :- A>= -3, A< -1, newp11(B).
%%% newp3([A|B]) :- A< -3, newp2(B).
%%% newp3([A|B]) :- A>5, newp2(B).
%%% newp11([A|B]) :- A>=1, A=<2, newp14(B).
%%% newp11([A|B]) :- A>= -1, A<1, newp3(B).
%%% newp11([A|B]) :- A< -1, newp2(B).
%%% newp11([A|B]) :- A>2, A=<4, newp14(B).
%%% newp11([A|B]) :- A>4, A=<5, newp14(B).
%%% newp11([A|B]) :- A>5, A=<7, newp19(B).
%%% newp11([A|B]) :- A>7, newp2(B).
%%% newp7([A|B]) :- A>=1, A=<2, newp21(B).
%%% newp7([A|B]) :- A>= -1, A=<0, newp7(B).
%%% newp7([A|B]) :- A>0, A<1, newp7(B).
%%% newp7([A|B]) :- A>= -3, A< -1, newp11(B).
%%% newp7([A|B]) :- A< -3, newp2(B).
%%% newp7([A|B]) :- A>2, A=<3, newp21(B).
%%% newp7([A|B]) :- A>3, A=<4, newp14(B).
%%% newp7([A|B]) :- A>4, A=<5, newp14(B).
%%% newp7([A|B]) :- A>5, A=<7, newp19(B).
%%% newp7([A|B]) :- A>7, newp2(B).