
mode(match,[+,+]).
mode(app,[-,-,+]).
mode(less_string,[+,+]).


match(A,B) :- app(C,D,B), app(E,F,C), less_string(A,F).
app([],A,A).
app([A|B],C,[A|D]) :- app(B,C,D).
less_string([],[]).
less_string([A|B],[C|D]) :- A=<C, less_string(B,D).


%%% solver:clpq
%%% uf: leftmost_weak_consumer
%%% wqounf: none
%%% sp_match(A) :- U=:=1, Z=:=0, D=:=2, match([U,Z,D],A).


%%%newp11(A).
%%%newp8(A).
%%%sp_match(A) :- newp2(A).
%%%newp2([A|B]) :- A>=1, newp3(B).
%%%newp2([A|B]) :- A<1, newp2(B).
%%%newp3([A|B]) :- A>=1, newp5(B).
%%%newp3([A|B]) :- A>=0, A<1, newp6(B).
%%%newp3([A|B]) :- A<0, newp2(B).
%%%newp6([A|B]) :- A>=2, newp8(B).
%%%newp6([A|B]) :- A>=1, A<2, newp3(B).
%%%newp6([A|B]) :- A<1, newp2(B).
%%%newp5([A|B]) :- A>=2, newp11(B).
%%%newp5([A|B]) :- A>=1, A<2, newp5(B).
%%%newp5([A|B]) :- A>=0, A<1, newp6(B).
%%%newp5([A|B]) :- A<0, newp2(B).

%%% sp_match(A) :- U=:=1, Z=:=0, D=:=2, match([U,D,Z],A).

%%%newp10(A).
%%%newp9(A).
%%%newp8(A).
%%%sp_match(A) :- newp2(A).
%%%newp2([A|B]) :- A>=1, newp3(B).
%%%newp2([A|B]) :- A<1, newp2(B).
%%%newp3([A|B]) :- A>=2, newp5(B).
%%%newp3([A|B]) :- A>=1, A<2, newp3(B).
%%%newp3([A|B]) :- A<1, newp2(B).
%%%newp5([A|B]) :- A>=2, newp8(B).
%%%newp5([A|B]) :- A>=1, A<2, newp9(B).
%%%newp5([A|B]) :- A>=0, A<1, newp10(B).
%%%newp5([A|B]) :- A<0, newp2(B).


%%% sp_match(A) :- U=:=1, Z=:=0, D=:=2, match([U,Z,D,U,Z],A).

%%%newp27(A).
%%%newp26(A).
%%%newp24(A).
%%%newp23(A).
%%%newp22(A).
%%%sp_match(A) :- newp2(A).
%%%newp2([A|B]) :- A>=1, newp3(B).
%%%newp2([A|B]) :- A<1, newp2(B).
%%%newp3([A|B]) :- A>=1, newp5(B).
%%%newp3([A|B]) :- A>=0, A<1, newp6(B).
%%%newp3([A|B]) :- A<0, newp2(B).
%%%newp6([A|B]) :- A>=2, newp8(B).
%%%newp6([A|B]) :- A>=1, A<2, newp3(B).
%%%newp6([A|B]) :- A<1, newp2(B).
%%%newp5([A|B]) :- A>=2, newp11(B).
%%%newp5([A|B]) :- A>=1, A<2, newp5(B).
%%%newp5([A|B]) :- A>=0, A<1, newp6(B).
%%%newp5([A|B]) :- A<0, newp2(B).
%%%newp11([A|B]) :- A>=2, newp15(B).
%%%newp11([A|B]) :- A>=1, A<2, newp16(B).
%%%newp11([A|B]) :- A>=0, A<1, newp6(B).
%%%newp11([A|B]) :- A<0, newp2(B).
%%%newp8([A|B]) :- A>=1, newp16(B).
%%%newp8([A|B]) :- A>=0, A<1, newp6(B).
%%%newp8([A|B]) :- A<0, newp2(B).
%%%newp16([A|B]) :- A>=2, newp22(B).
%%%newp16([A|B]) :- A>=1, A<2, newp23(B).
%%%newp16([A|B]) :- A>=0, A<1, newp24(B).
%%%newp16([A|B]) :- A<0, newp2(B).
%%%newp15([A|B]) :- A>=2, newp26(B).
%%%newp15([A|B]) :- A>=1, A<2, newp27(B).
%%%newp15([A|B]) :- A>=0, A<1, newp24(B).
%%%newp15([A|B]) :- A<0, newp2(B).