
mode(match,[+,+]).
mode(app,[-,-,+]).
mode(string_sum,[+,+]).
mode(len,[+,+]).


match(A,L,B) :-
%match(A,B) :-	
	app(C,D,B), app(E,F,C),
	len(F,L),
	string_sum(F,A).

app([],A,A).
app([A|B],C,[A|D]) :- app(B,C,D).

len([],X) :- X=:=0.
len([_|B],C) :- C=:=D+1, len(B,D).

string_sum([],X) :- X=:=0.
string_sum([A|B],C) :- C=:=D+A, string_sum(B,D).

%%% solver:clpq
%%% uf: leftmost_weak_consumer
%%% wqounf: none
%%% match_sp(A) :- B=:=0, match(B,A).

