mode(m_match,[+,+]).
mode(match,[+,+]).
mode(app,[-,-,+]).
mode(less_string,[+,+]).


m_match([W|Ws],T) :-
	match(W,T).
m_match([W|Ws],T) :-
	m_match(Ws,T).

match(W,T) :-
	app(Z,_,T),       
	app(Left,W1,Z),
	less_string(W,W1).


app([],L,L).
app([A|L1],L2,[A|L3]):-
	app(L1,L2,L3).


less_string([],[]).
less_string([A|B],[C|D]) :- A=<C, less_string(B,D).


%%% solver:clpq
%%% uf: leftmost_weak_consumer
%%% wqounf: none
%%% Z=:=0, U=:=1, D=:=2, T=:=3, Q=:=4,
%%% sp_mm(A) :-  U=:=1, D=:=2, m_match([[U,U,U],[U,U,D]],A).
%%% sp_mm(A) :-  U=:=1, D=:=2, m_match([[U,U,U],[U,U,D],[U,U]],A). 
%%% sp_mm(A) :-  U=:=1, D=:=2,  T=:=3, m_match([[U,U,D],[U,D,T]],A).
%%% sp_mm(A) :-  U=:=1, D=:=2,  m_match([[U,U,D],[U,D,D]],A).