:- asserta(file_search_path(library,'$NEWMAP_DIR/src_sics/maplib')).
:- use_module(library(tcltk)).
:- use_module(library(mapconcat)).
:- use_module(library(conversion)).
:- use_module(library(yes_xtk)).
:- ['src_sics/srcMain'].


map :-
        initialize_tk,
        load_tcl_files,
        tk_main_loop.
initialize_tk :-
        tk_new([name('MAP')],I),
        initialize_flag(map_tcl_interp,I).
load_tcl_files :-
        Lib='$env(NEWMAP_DIR)/src_tcl',
        concat_all(['set auto_path [linsert $auto_path 0 ', Lib,']'],Cmd1),
        tcl_eval(Cmd1),
        concat_all(['set src_gui ',Lib], Cmd2),
	tcl_eval(Cmd2),
        concat_all(['source ',Lib,'/mapMain.tcl'], Cmd3),		  
        tcl_eval(Cmd3).		  


:-
	set_current(debug,yes),
	map.