:- discontiguous widening/5.
:- discontiguous is_a_widening/2.

:- multifile css_param_info/2.
:- discontiguous css_param_info/2.

:- use_module(library(lists), [ member/2 ]).


is_a_widening(widening_simple,_).

widening(widening_simple,Solver,C1,C2,C3) :-
	(satisfiable(Solver,C2) ->
	    primitives(C1,PC1),
	    keep_entailed(Solver,PC1,C2,C3)
	;
	    throw(widening_exception)
	).

css_param_info(widening_simple,[display('Simple')]).


%%%:- dynamic lang_preds/1.
%%%:- dynamic lang_consts/1.
%%%:- retractall(lang_preds(_)),retractall(lang_consts(_)),
%%%	%%% bakery starvation freedom
%%%	%%% also verified with Consts = [0,1]
%%%%%%	Preds = ['>','<','=:=','>=','=<'], Consts = [0], % CTLbakery2
%%%%%%	Preds = ['>','>='], Consts = [0], % CTLticket2 +++++++ try adding =:=
%%%%%%	Preds = ['>','>=','=:='], Consts = [0], 
%%%%%%	Preds = ['=:=','>','<'], Consts = [0],
	
%%%	Preds = ['<','=:=','=<','>','>='], Consts = [0,1], % CTLex5 p1-p1a wqounf_always
	
%%%	assert(lang_preds(Preds)),assert(lang_consts(Consts)),	
%%%	set_current(widening,widening_lang).

%%%is_a_widening(widening_lang,_).

%%%widening(widening_lang,Solver,_C1,C2,C3) :-
%%%	free_variables(C2,[],[],VC2),
%%%	lang_preds(Preds),lang_consts(Consts),
%%%	generate_constraint(VC2,Preds,Consts,PC1),
%%%	keep_entailed(Solver,PC1,C2,C3temp),
%%%	solve(Solver,C3temp,VC2,C3).



is_a_widening(pred_abs,_).

%%% Warning: this use of widening/5 has wrong type:
%%% 
widening(pred_abs,Solver,State,C2,C3) :-
	setof(C,
	      S1^(State=S1,
		  (pred_abs(S1,C)
		  ;
		      (NC^(pred_abs(S1,NC),negate(Solver,NC,C)))
		  )
		 )
	     ,PC1),
	keep_entailed(Solver,PC1,C2,C3temp),
	%%% needed?
	free_variables(C2,[],[],VC2),
	solve(Solver,C3temp,VC2,C3).